import * as echarts from "echarts";
import { chartsWidth,emptyData,dataLength, handelProfitrate, handelZoom, handelLineType, handelSwitchs, handelWatermark, handelSmaData, getDateArray, fetchBtcPrice, fetchEthPrice } from "../../util/processingData"
export default {
    data() {
        return {
            lengthTimer:null,
            option: {
                tooltip: {
                    trigger: "axis",
                    //解决tooltip显示不全问题1 
                    confine: true,
                    formatter: function (params) {
                        const date = new Date(params[0].value[0]);
                        const year = date.getFullYear();
                        const month = date.getMonth() + 1;
                        const day = date.getDate();
                        let time =  `${year}-${month}-${day}`;
                        var res =time                       

                        for (let i = 0; i < params.length; i++) {
                            res += `</br>${params[i].marker} ${params[i].seriesName} &nbsp&nbsp&nbsp&nbsp <span style="font-weight: bold">${params[i].value[1]}</span>`

                        }
                        return res;
                    }
                },
                legend: {
                    right: "100"
                },
                xAxis: {
                    type: "time",
                    // boundaryGap: [0.1, 0.1],
                    //   axisLabel: {
                    //     formatter: `{yyyy}-{MM}-{dd}`,
                    //   },
                    data: []
                },
                yAxis: [
                    {
                        type: "value",
                        // show:"false",
                        // boundaryGap: [0, "100%"],
                        // axisLabel: {
                        //   formatter: function (e) {

                        //     let value;
                        //     if (e > 1000000) {
                        //       value = e / 100000;
                        //     } else if (e > 100000) {
                        //       value = e / 1000;
                        //     } else {
                        //       value = e / 100;
                        //     }
                        //     return value;
                        //   },
                        // },
                        min: "dataMin",
                        max: "dataMax",
                        // axisLine: {
                        //     show: true, // 显示 Y 轴线条
                        //   },
                   
                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: true,
                        position: "right",
                        // axisLine: {
                        //     show: true, // 显示 Y 轴线条
                        //   },
                      
                    
                    },
                    {
                        type: "value",
                        // boundaryGap: [0, "100%"],
                        show: false,
                    },
                ],
               
                dataZoom: [
                    {
                        type: "inside",
                        start: 0,
                        end: 100,
                    },
                    {
                        start: 0,
                        end: 100,
                    },
                ],
                series: [
                    {
                        name: "Circulating Supply (USDC)",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        showSymbol: false,
                        symbolSize: 5,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#f7931a",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#f7931a",
                            width: "1",
                        },
                        data: [],

                    },
                    {
                        name: "Price[BTC]",
                        type: "line",
                        smooth: false,
                        symbol: "circle",
                        symbolSize: 5,
                        showSymbol: false,
                        // areaStyle: {},
                        itemStyle: {
                            color: "#888888",
                            borderColor: "rgba(221,220,107,0.1)",
                            borderWidth: 12,
                        },
                        lineStyle: {
                            //线条样式
                            color: "#888888",
                            width: "1",
                        },
                        yAxisIndex: 1,
                        data: [],
                     
                    
                    },
                    // {
                    //     name: "Price [ETH]",
                    //     type: "line",
                    //     smooth: false, //线条是否圆滑
                    //     symbol: "circle",
                    //     symbolSize: 5,
                    //     showSymbol: false,
                    //     itemStyle: {
                    //       color: "#627eea",
                    //       borderColor: "rgba(221,220,107,0.1)",
                    //       borderWidth: 12,
                    //     },
                    //     lineStyle: {
                    //       //线条样式
                    //       color: "#627eea",
                    //       width: "1",
                    //     },
                    //     yAxisIndex: 2,
                    //     data: [],
                    //   },

                ],
            },
            params: {
                req: "csusdc",
                radius: "eth"
            },
            circulationUSDCLoading: false,
            switch3: "",
            btcFlag: null,
            ethFlag: null,
            fatherSmaData: [],
            start: "",
            end: "",
            parmesTime: {
                start: "",
                end: ""
            },
            sma: "",
            zoomStart: 0,
            zoomEnd: 0,
        }
    },
    mounted() {
        this.fetchCirculation(this.params.req, this.params.radius)
        this.switch3 = handelSwitchs(this.option, this.switch3)

        this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
        this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
        this.$addStorageEvent(1, "zoomStart", this.zoomStart);
        this.$addStorageEvent(1, "zoomEnd", this.zoomEnd);
        window.addEventListener("setItem", () => {
            this.ethFlag = JSON.parse(localStorage.getItem("ethFlag"));
            this.btcFlag = JSON.parse(localStorage.getItem("btcFlag"));
            this.zoomStart = localStorage.getItem("zoomStart")
            this.zoomEnd = localStorage.getItem("zoomEnd")

        })
    },
    methods: {
        //初始化图表
        inCharts() {
            if (this.myChart == null) {
                this.myChart = echarts.init(document.getElementById("circulationUSDCBox"));
            }
            this.option = handelZoom(this.myChart, this.option, this, this.zoomStart, this.zoomEnd)
        
            this.myChart.setOption(this.option);
            chartsWidth("circulationUSDCBox", this);
            window.addEventListener("resize", () => {
                if (this.myChart) this.myChart.resize();
            });
        },
        //请求数据并渲染
        async fetchCirculation(req, radius, start, end, sma) {
            this.circulationUSDCLoading = true
            const { data } = await this.$API.getProfitrate(req, radius, start, end, sma)
            let usdcData = data.data
            //空数据处理
            let noData = emptyData(data.data, this.option.series, this.inCharts, this)
            if (noData) {
                this.circulationUSDCLoading = false
                return
            }
            this.start = usdcData[0].date.split("T")[0]
            this.end = usdcData[usdcData.length - 1].date.split("T")[0]
            //添加水印
            this.option = handelWatermark(this.option)

          



            //根据渲染的数据时间渲染对应的价格线和移动平均线
            // this.$nextTick(() => {
            //     //移动平均线没值 才渲染正常价格数据 
            //     if (this.start && !this.fatherSmaData[0]) {
            //         this.handelSonBtcPrice("BTC", true)


            //     }
            //     //点击时间 移动平均线有值 就渲染查询移动平均线
            //     if (this.fatherSmaData[0] && this.start) {
            //         this.handelSonSma(this.fatherSmaData, this.start, this.end)

            //     }
            //     //渲染ETH
            //     if (this.ethFlag) {

            //         this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));
            //         this.handelSonEthPrice("ETH", this.ethFlag)
            //     }
            //     //渲染BTC价格
            //     if (this.btcFlag) {
            //         this.$addStorageEvent(1, "btcFlag", JSON.stringify(this.btcFlag));
            //         this.handelSonBtcPrice("BTC", this.btcFlag)
            //     }
            // })
            this.handelSonBtcPrice("BTC", true)
            let ValueList = []
            usdcData.forEach(item => {
                ValueList.push(Number(item.value.toFixed(2)))
            })
            this.option.series[0].data = handelProfitrate(usdcData, ValueList)

            this.inCharts()

            console.log(this.option,"机密级");
            
            this.circulationUSDCLoading = false
             //判定页面条数是否一致
             if (this.lengthTimer) {
                clearTimeout(this.lengthTimer)
            }
            this.lengthTimer = setTimeout(() => {
                this.$addStorageEvent(1, "lengthFlag", dataLength(this.option, this.option.series[0].data.length), );

            }, 10000)
        },
        //接收Home传的时间handelParmesTime
        handelSonTime(start, end) {
            this.parmesTime.start = start;
            this.parmesTime.end = end;
            this.fetchCirculation(this.params.req, this.params.radius, this.parmesTime.start, this.parmesTime.end, this.sma)
            // this.handelSonEthPrice()

        },

        //点击对数/线性按钮切换
        handelLineSwitch() {
            this.option = handelLineType(this.option)
            this.switch3 = handelSwitchs(this.option, this.switch3)
            this.myChart.setOption(this.option);

        },

        //父级点击BTC价格按钮
        handelSonBtcPrice(radius, flag) {
            this.btcFlag = flag
            fetchBtcPrice("BTC", this.option.series[1], this.start, this.end, this.inCharts, this, this.btcFlag)


        },
        //父级点击ETH价格按钮
        handelSonEthPrice(radius, flag) {

            this.ethFlag = flag

            fetchEthPrice("ETH", this.option.series[2], this.start, this.end, this.inCharts, this, this.ethFlag, true)
            this.$addStorageEvent(1, "ethFlag", JSON.stringify(this.ethFlag));

        },
        //父级选择Sma
        handelSonSma(smaDataList) {

            this.sma = smaDataList
            this.fetchCirculation(this.params.req, this.params.radius, this.parmesTime.start, this.parmesTime.end, this.sma)
            this.$addStorageEvent(1, "sma", this.sma);



            // this.fatherSmaData = smaDataList      
            // handelSmaData(smaDataList,this.option.series[1],this.inCharts,this.start, this.end)

        },

    },
    beforeDestroy() {
        if (this.lengthTimer) {
            clearTimeout(this.lengthTimer)
        }
    }
}